package cn.com.infosec.asn1.crmf;

import cn.com.infosec.asn1.ASN1Encodable;
import cn.com.infosec.asn1.ASN1EncodableVector;
import cn.com.infosec.asn1.ASN1Sequence;
import cn.com.infosec.asn1.DERInteger;
import cn.com.infosec.asn1.DERObject;
import cn.com.infosec.asn1.DERSequence;

public class CertRequest extends ASN1Encodable {
   private DERInteger certReqId;
   private CertTemplate certTemplate;
   private Controls controls;

   private CertRequest(ASN1Sequence seq) {
      this.certReqId = DERInteger.getInstance(seq.getObjectAt(0));
      this.certTemplate = CertTemplate.getInstance(seq.getObjectAt(1));
      if (seq.size() > 2) {
         this.controls = Controls.getInstance(seq.getObjectAt(2));
      }

   }

   public static CertRequest getInstance(Object o) {
      if (o instanceof CertRequest) {
         return (CertRequest)o;
      } else if (o instanceof ASN1Sequence) {
         return new CertRequest((ASN1Sequence)o);
      } else {
         throw new IllegalArgumentException("Invalid object: " + o.getClass().getName());
      }
   }

   public DERInteger getCertReqId() {
      return this.certReqId;
   }

   public CertTemplate getCertTemplate() {
      return this.certTemplate;
   }

   public Controls getControls() {
      return this.controls;
   }

   public DERObject toASN1Object() {
      ASN1EncodableVector var1;
      ASN1EncodableVector var10001 = var1 = new ASN1EncodableVector;
      var1.<init>();
      var1.add(this.certReqId);
      var10001.add(this.certTemplate);
      Controls var2;
      if ((var2 = this.controls) != null) {
         var1.add(var2);
      }

      return new DERSequence(var1);
   }
}
